var pcolortext, pcolorbg, pbordercolor, pbordermode, pborderwidth, pgraphicalq, pborderleftstyle, pborderrightstyle, pbordertopstyle, pborderbottomstyle;
colors_fg = new Array(MAX_LEVELS);
colors_bg = new Array(MAX_LEVELS);

function getColorsAndPrefs()
{
  var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

  var prefstringfg = "quotecolors.fg.l";
  var prefstringbg = "quotecolors.bg.l";
      
  for( var i=0; i<MAX_LEVELS; i++)
  {
    colors_fg[i] = pref.getCharPref(prefstringfg + (i+1));
    colors_bg[i] = pref.getCharPref(prefstringbg + (i+1));
  }

  pcolortext = pref.getBoolPref("quotecolors.colorText");
  pcolorbg = pref.getBoolPref("quotecolors.colorBackground");
  
  // is graphical quoting enabled?
  pgraphicalq = ( pref.getBoolPref("mail.quoted_graphical") ||
                  !pref.getBoolPref("mailnews.display.disable_format_flowed_support") );

  if(pgraphicalq)
  {
    pbordermode = pref.getIntPref("quotecolors.borderMode");
    var index_borderstyle = pref.getIntPref("quotecolors.borderstyle");
    var borderstyle = arr_borderstyle[index_borderstyle];

    pbordercolor = pref.getCharPref("quotecolors.bordercolor");
    var index_borderwidth = pref.getIntPref("quotecolors.borderwidth");
    pborderwidth=arr_borderwidth[index_borderwidth];
    
    pborderleftstyle = pref.getBoolPref("quotecolors.borderposition.left") ? borderstyle : "none";
    pborderrightstyle = pref.getBoolPref("quotecolors.borderposition.right") ? borderstyle : "none";
    pbordertopstyle = pref.getBoolPref("quotecolors.borderposition.top") ? borderstyle : "none";
    pborderbottomstyle = pref.getBoolPref("quotecolors.borderposition.bottom") ? borderstyle : "none";
  }

}


function setViewQuotecolor()
{

  var content = getMessageBrowser();
  if(!content) return;
  var mailmsg = content.contentDocument;
  
  // does not seem to be a valid message
  if(! mailmsg.getElementsByTagName("div").item(0) )
    return;

  // temporary: we don't color blockquotes in HTML messages
  if( mailmsg.getElementsByTagName("div").item(0).getAttribute("class")=="moz-text-html" )
    return;

  if(! mailmsg.getElementsByTagName("blockquote").item(0) )
    return;  // there are no quotes in the message so we don't change anything

  getColorsAndPrefs();

  var StyleElement = mailmsg.createElement("style");
  StyleElement.type = "text/css";
  
  const bqselector = "blockquote[type=cite] ";
  var stylecontent="";


  for(var i=0;i<MAX_LEVELS; i++) {

    for(var j=0;j<=i;j++) {
      stylecontent += bqselector;
    }
    
    stylecontent += "{";
    
      // text color
      stylecontent += "color:" + ( pcolortext ? colors_fg[i] : "inherit" ) + " !important;";
    
      // background color
      if(pcolorbg)
        stylecontent += "background-color:"+ colors_bg[i] + " !important;";
      
      // only add/style borders if graphical quoting is enabled  
      if(pgraphicalq)
      {
        stylecontent += "border-color:"+ ( (pbordermode==0) ? colors_fg[i] : pbordercolor ) + " !important;";
        stylecontent += "border-width: " + pborderwidth + " !important;"
        stylecontent += "border-style: "+pbordertopstyle+" "+pborderrightstyle+" "+pborderbottomstyle+" "+pborderleftstyle+" !important;";
      }
      else
      {
        stylecontent += "border:none !important;";
        stylecontent += "padding:0em !important;";
      }
  
    stylecontent += "}\n";
  }
  
  var styletext = document.createTextNode(stylecontent);
  StyleElement.appendChild(styletext);
    
  mailmsg.getElementsByTagName("head")[0].appendChild(StyleElement);

}
